

/**
 * implementation du producteur consommateur avec un buffer circulaire
 */
public class BufferCirc {

	private Object[] tampon;
	private int taille;
	private int prem, der, nbObj;


	public BufferCirc (int t) {
		taille = t;
		tampon = new Object[taille];
		prem = 0;
		der = 0;
		nbObj = 0;
	}


	public boolean isEmpty() {
		return nbObj == 0;
	}


	public boolean isFull() {
		return nbObj == taille;
	}


	public synchronized void depose(Object obj) {
		while(isFull()) {
			try {
				System.out.println("Buffer is full: " + Thread.currentThread().getName()
								   + " is waiting, size: " + nbObj);
				wait();
			}
			catch (InterruptedException e) {
				System.err.println("InterruptedException: " + e);
			}
		}
		nbObj++;
		tampon[prem] = obj;
		prem = (prem + 1) % taille;
		//System.out.println(Thread.currentThread().getName() + " a depose " + (Integer)obj);
		notifyAll();
	}


	public synchronized Object preleve() {
		while(isEmpty()) {
			try {
				System.out.println("Buffer is empty: " + Thread.currentThread().getName()
								   + " is waiting, size: " + nbObj);
				wait();
			}
			catch (InterruptedException e) {
				System.err.println("InterruptedException: " + e);
			}
		}
		Object outObj = null;
		nbObj--;
		outObj = tampon[der];
		der = (der + 1) % taille;
		//System.out.println(Thread.currentThread().getName() + " a preleve " + (Integer)outObj);
		notifyAll();
		return outObj;
	}

} // fin class BufferCirc
