import java.net.*;
import java.io.*;

public class Main {
	public static void main(String[] args) {
		ServerSocket listenSocket = null;
		try {
			System.out.println("Demarrage du serveur sur le port "
								+ Integer.parseInt(args[0]) + " et en attente de connexion :");
			listenSocket = new ServerSocket(Integer.parseInt(args[0])); // port
			while (true) { // le dispatcher est le thread qui execute main()
				Socket clientSocket = listenSocket.accept();
				System.out.println("Connexion de :" + clientSocket.getInetAddress());
				//Launch the text broadcasting server
				Thread serviceThread = new Thread(new BroadcastThreadService(clientSocket));
				//Or lauch the object broadcasting server
				//Thread serviceThread = new Thread(new BroadcastoThreadService(clientSocket));
				serviceThread.start();
			}
		}
		catch (Exception e) {
			System.err.println("IOException : " + e);
			e.printStackTrace();
		}
		finally {
			try {
				if (listenSocket != null)
					listenSocket.close();
			}
			catch (IOException e) {
				System.err.println("IOException : " + e);
				e.printStackTrace();
			}
		}
	}

}
